﻿Imports System.Globalization
Imports System.Runtime.InteropServices
Imports System.Text
Module GlobalesModul
    Public Programmverzeichnis As String
    Public BrailleUebersetzungstabelle As String = ""
    Public BrailleAusgabetabelle As String = ""
    Public Eintrag() As String
    Public Brailletabellenliste As New List(Of String)
    Public Dateiinhalt As System.IO.StreamReader
    Public AktuelleZeile As String = ""
End Module

Class LibLouis
    Public Shared Function Translate(Input As String) As String
        Dim InputLen As Int32 = Input.Length
        Dim OutputLen As Int32 = Input.Length + 32
        Dim Output As New StringBuilder
        Dim typeform() = Enumerable.Repeat(NativeMethods.Typeforms.plain_text, OutputLen).ToArray()
        NativeMethods.lou_translateString("\braille\Brailletabellen\" & BrailleUebersetzungstabelle, Input, InputLen, Output, OutputLen, Nothing, Nothing, 0)
        Return Output.ToString
    End Function

    Public Shared Function LiblouisVersion() As String
        Dim Adresse = NativeMethods.lou_version()
        Dim Rueckgabe As String = Marshal.PtrToStringAnsi(Adresse)
        Return Rueckgabe
    End Function
End Class

Class NativeMethods
    <DllImport("liblouis.dll", BestFitMapping:=False, ThrowOnUnmappableChar:=True, CharSet:=CharSet.Auto)>
    Public Shared Function lou_version() As IntPtr
    End Function

    <DllImport("liblouis.dll", BestFitMapping:=False, ThrowOnUnmappableChar:=True, CharSet:=CharSet.Auto)>
    Public Shared Function lou_translateString(
        <MarshalAs(UnmanagedType.LPStr)> tableList As String,
        <MarshalAs(UnmanagedType.LPWStr)> inbuf As String,
        ByRef inlen As Int32,
        <MarshalAs(UnmanagedType.LPWStr), Out()> outbuf As StringBuilder,
        ByRef outlen As Int32,
        Typeform() As Typeforms,
        <MarshalAs(UnmanagedType.LPStr)> spacing As String,
        mode As Int32) As Int32
    End Function
    Public Enum TranslationModes
        noContractions = 1
        compbrlAtCursor = 2
        dotsIO = 4
        comp8Dots = 8
        pass1Only = 16
        compbrlLeftCursor = 32
        otherTrans = 64
        ucBrl = 128
    End Enum

    Public Enum Typeforms As UShort
        plain_text = &H0
        italic = &H1     ' emph_1 
        underline = &H2  ' emph_2 
        bold = &H4       ' emph_3 
        emph_4 = &H8
        emph_5 = &H10
        emph_6 = &H20
        emph_7 = &H40
        emph_8 = &H80
        emph_9 = &H100
        emph_10 = &H200
        computer_braille = &H400
        no_translate = &H800
        no_contract = &H1000
    End Enum
End Class